/*
 * Copyright 2014-2018 Adrian Thurston <thurston@colm.net>
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to
 * deal in the Software without restriction, including without limitation the
 * rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
 * sell copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */

#ifndef RAGEL_BINBREAK_H
#define RAGEL_BINBREAK_H

#include "binary.h"
#include "actloop.h"
#include "actexp.h"

struct BinBreak
:
	public Binary, public TabBreak
{
	BinBreak( const CodeGenArgs &args, Binary::Type type )
	:
		Tables( args ),
		Binary( args, type ),
		TabBreak( args )
	{}

	void LOCATE_TRANS();
	void LOCATE_COND();
};

class BinBreakLoop
	: public BinBreak, public ActLoop
{
public:
	BinBreakLoop( const CodeGenArgs &args )
	:
		Tables( args ),
		BinBreak( args, Loop ),
		ActLoop( args )
	{}
};


class BinBreakExp
	: public BinBreak, public ActExp
{
public:
	BinBreakExp( const CodeGenArgs &args ) 
	:
		Tables( args ),
		BinBreak( args, Exp ),
		ActExp( args )
	{}
};


#endif
